//-----------------------------------------------------------------------------------
// DFS modified from file $LEDAROOT/src/graph_alg/_dfsnum.c. 
//
//Credits:
//--------
//  
//  Alexandre Noma                <noma@ime.usp.br> -- supported by Fapesp.
//  Cristina Gomes Fernandes      <cris@ime.usp.br>
//  John M. Boyer                 <jboyer@acm.org>
//  Jose Coelho de Pina Junior    <coelho@ime.usp.br>
//
//  Institute of Mathematics and Statistics - University of Sao Paulo - Brazil
//-----------------------------------------------------------------------------------

#include <LEDA/graph.h>
#include <LEDA/node_array.h>
#include <LEDA/list.h>

#if defined(LEDA_NAMESPACE)
using namespace leda;
#endif

static int count1;
static int count2;
void dfs_aux(
	     node v,
	     node_array<int>& dfspre,
	     node_array<int>& dfspos,
	     list<edge>& T)
{ 
  dfspre[v] = count1++;
  edge e;
  forall_out_edges (e, v) 
    { 
      node w = target(e);
      if (dfspre[w] == 0) 
        { 
          T.append(e);
          dfs_aux(w, dfspre, dfspos, T);
        }
    }
  dfspos[v] = count2++;
} 

list<edge> DFS_POS(
		   const graph& G,
		   node_array<int>& dfspos)
{ 
  list<edge> T;
  node_array<int> dfspre(G, 0);
  node v;

  count1 = count2 = 1;
  forall_nodes (v, G) 
    if (dfspre[v] == 0) 
      dfs_aux(v, dfspre, dfspos, T);
  return T;
}
//-----------------------------------------------------------------------------------
